-- this is what you do to add a new item
local width, height = get_window_size()
local options = { name = 0, timer = 0, uke = 0, score = 0, hint = 0, feedback = 0 }
local BTN_UP = 1
local BTN_HOVER = 2
local BTN_DOWN  = 3
local buttonW = 18
local buttonH = 18
local currentButton = 0
local button = {}
local shopCategories = {}
local shopCatCount = 1
local catSelected = 1
local shopItems = {price = {}, stock = {}, image = {}, itemId = {}, itemName = {}, colorid = {}}
local shopItemCount = 1
local shelf = 0
local currentShelf = 1
local lastShelfItems = 10
local shelfItemNum = {}
local itemPerShelf = {}
local shop = {"catId", "catName", "itemId", "itemName", "price", "stock", "image", "rentable", "tradeable", "ingame", "colorid"}
for k, v in pairs(shop) do
	shop[v] = {}
end
local shopCount = 1
local toriCredits = 0
local originalVolume = 0
local available = false 
local shopCat = {}
local lineSpace = 18

function getShopItemsFromFile()
	file = io.open("torishop/torishop.txt") --'http://www.toribash.com/dump/store.php
	if file == nil then
		return 0
 	end

	for ln in file:lines() do
		if string.match(ln, "^CREDIT") then
			ln = string.gsub(ln, "CREDIT\t", "")
			toriCredits = tonumber(ln) 
        	elseif string.match(ln, "^PRODUCT") then
                	nsep = 12
                	-- split a tab separated string into an array
                	dat = { ln:match(("([^\t]*)\t"):rep(nsep)) }
			for k, z in ipairs(shop) do
				shop[z][shopCount] = dat[k + 1]
			end
			shopCount = shopCount + 1
		elseif string.match(ln, "^#tag") then
			available = true 
		end
	end
	file:close()
end

function getCategories()
	preValue = ""
	for key, value in pairs(shop.catName) do
  		if value ~= preValue then
			shopCategories[shopCatCount] = value
			if value == "Blood Colors" then
				shopCat[shopCatCount] = { tempStuff = 'blood', tryAble = true, color = 0, tryName = "", setColor = set_blood_color }
			elseif value == "Relax Colors" then
				shopCat[shopCatCount] = { tempStuff = 'joint_R', tryAble = true, color = 0, tryName = "", setColor = set_joint_relax_color  }
			elseif value == "Force Colors" then
				shopCat[shopCatCount] = { tempStuff = 'joint_F', tryAble = true, color = 0, tryName = "", setColor = set_joint_force_color  }
			elseif value == "Torso Colors" then
				shopCat[shopCatCount] = { tempStuff = 'torso', tryAble = true, color = 0, tryName = "", setColor = set_torso_color }
			elseif value == "Ghost Colors" then
				shopCat[shopCatCount] = { tempStuff = 'ghost', tryAble = true, color = 0, tryName = "", setColor = set_ghost_color  }
			elseif value == "DQ Rings" then
				shopCat[shopCatCount] = { tempStuff = 'dqRing', tryAble = true, color = 0, tryName = "", setColor = set_ground_impact_color }
			elseif value == "Secondary Gradients" then
				shopCat[shopCatCount] = { tempStuff = 'gradient_S', tryAble = true, color = 0, tryName = "", setColor = set_gradient_secondary_color }
			elseif value == "Primary Gradients" then
				shopCat[shopCatCount] = { tempStuff = 'gradient_P', tryAble = true, color = 0, tryName = "", setColor = set_gradient_primary_color }
			elseif value == "Trail Colors" then
				shopCat[shopCatCount] = { tempStuff = 'trail_col', tryAble = true, color = 0, tryName = "", setColor = set_trail_color }
			else 
				shopCat[shopCatCount] = { tempStuff = '', tryAble = false, color = 0, tryName = "", setColor = function() end }
			end
			shopCatCount = shopCatCount + 1
			preValue = value
		end
	end
	shopCatCount = shopCatCount - 1
end

local function tsUnavailable()
	local jx, jy, jz = get_joint_pos (0, 1) --chest
	set_camera_lookat(jx, jy, 1.5)
	set_color(0.5, 0.5, 0.5, 0.4)
	draw_quad(quadStartPos.x, quadStartPos.y, 320, 60)
	set_color(0, 0, 0, 1)
	draw_text("Sorry the ToriShop is currently unavailable...", 5, 5)
	setButtonColor("online")
	draw_text("Click here to go to the Online ToriShop", online.pos.x, online.pos.y) 
end

function init()
	getShopItemsFromFile();
	getCategories();
	placeItems();
	run_cmd ("clear")
	init_mod_world()
	originalVolume = get_volume()
	set_volume(0)
	-- Remove default game interface
	for k, v in pairs(options) do
		options[k] = get_option(k)
		set_option(k, 0)
	end

	quadStartPos = {x = 0, y = 0}
	quadWidth = 510
	quadHeight = height
	link = {pos = {x = quadWidth - 150, y = quadHeight - 25}, dim = {w = 130, h = 20}}
	online = {pos = {x = 5, y = 30}, dim = {h = 20, w = 280}}
	catButtonPos = {x = quadStartPos.x + 20, x2 = quadStartPos.x + 160, y = quadStartPos.y + 60}
	catHitboxPos = {x = catButtonPos.x - buttonW/2, x2 = catButtonPos.x2 - buttonW/2, y = catButtonPos.y - buttonH/2}
        itemButtonPos = {x = quadStartPos.x + 20, x2 = quadWidth - 20, y = quadHeight/2}
	itemHitboxPos = {x = itemButtonPos.x - buttonW/2, x2 = itemButtonPos.x2 - buttonW/2, y = itemButtonPos.y - buttonH/2}
	try = {pos = {x = 150, y = 55}, dim = {w = 40, h = 20}}
	none = {pos = {x = catButtonPos.x2  + 20, y = catButtonPos.y - 10}, dim = {w = 45, h = 20}}
	buy = {pos = {x = 200, y = 55}, dim = {h = 20, w = 45}}
	tc = { pos = { x = 520, y = 450 }} 

	button["prev_cat"] = {x = catHitboxPos.x, y = catHitboxPos.y, w = buttonW, h = buttonH, state = BTN_UP} 
	button["next_cat"] = {x = catHitboxPos.x2, y = catHitboxPos.y, w = buttonW, h = buttonH, state = BTN_UP} 
	button["prev_item"] = {x = itemHitboxPos.x, y = itemHitboxPos.y, w = buttonW, h = buttonH, state = BTN_UP}
	button["next_item"] = {x = itemHitboxPos.x2, y = itemHitboxPos.y, w = buttonW, h = buttonH, state = BTN_UP}
	button["none"] = {x = none.pos.x, y = none.pos.y, w = none.dim.w, h = none.dim.h, state = BTN_UP}
	button['link'] = {x = link.pos.x, y = link.pos.y, w = link.dim.w, h = link.dim.h, state = BTN_UP}
	button['online'] = {x = online.pos.x, y = online.pos.y, w = online.dim.w, h = online.dim.h, state = BTN_UP}

	alignment = 1
	for i = 1, 10 do
		if i%2 == 1 then
			button[i .. "_buy"] = {x = buy.pos.x, y = buy.pos.y + (alignment*100), w = buy.dim.w, h = buy.dim.h, state = BTN_UP}
			button[i .. "_try"] = {x = try.pos.x, y = try.pos.y + (alignment*100), w = try.dim.w, h = try.dim.h, state = BTN_UP}
		else
			button[i .. "_buy"] = {x = buy.pos.x + 220, y = buy.pos.y + (alignment*100), w = buy.dim.w, h = buy.dim.h, state = BTN_UP}
			button[i .. "_try"] = {x = try.pos.x + 220, y = try.pos.y + (alignment*100), w = try.dim.w, h = try.dim.h, state = BTN_UP}
			alignment = alignment + 1
		end
	end
	updateTori()
end

function drawItem(posX, posY, text_Offset_X, text_Offset_Y, name, price, stock)
	itemSelectedHighlight(0.74, 0.72, 0.42, 1, 0.93, 0.87, 0.51, 1, name)
	draw_quad(posX, posY, 200, 90)
	itemSelectedHighlight(0.7, 0.7, 0.7, 1, 0.92, 0.92, 0.92, 1, name)
	draw_quad(posX + 10, posY + 5, 180, 80)
	itemSelectedHighlight(0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.5, name)
	if string.find(name, "ondary") ~= nil then
		name = string.gsub(name, "ondary", ".")
	elseif string.find(name, "mary") then
		name = string.gsub(name, "mary", ".")
	end

	if string.find(name, "ient") ~= nil then
		name = string.gsub(name, "ient", "")
	end
	draw_text(string.upper(name), posX + 10, posY + 5)
	draw_text("Price: ", posX + 10, posY + (lineSpace*1) + 5)
	draw_text(price, posX + 60, posY + (lineSpace*1) + 5)
	draw_text("Stock: ", posX + 10, posY + (lineSpace*2) + 5)
	draw_text(stock, posX + 60, posY + (lineSpace*2) + 5)
end

function itemSelectedHighlight(r1, g1, b1, a1, r2, g2, b2, a2, name)
	if shopCat[catSelected].tryName == name then
		set_color(r1, g1, b1, a1)
	else
		set_color(r2, g2, b2, a2)
	end
end

function placeItems()
	for key, value in pairs(shop.catName) do
		if value == shopCategories[catSelected] then
			for k, v in pairs(shopItems) do
				shopItems[k][shopItemCount] = shop[k][key]
			end
	 		shopItemCount = shopItemCount + 1	
		end
	end

	shopItemCount = shopItemCount - 1
	shelf = math.floor(shopItemCount/10)

	if shopItemCount%10 ~= 0 then
		shelf = shelf + 1
		lastShelfItems = shopItemCount%10
	else
		lastShelfItems = 10 
	end

	for i = 1, shelf-1 do
		itemPerShelf[i] = 10
	end
	itemPerShelf[shelf] = lastShelfItems
end

function drawItemsOnShelf()
 	alignment = 1
 	buttonNumber = 1
 	firstItem = (10*currentShelf) - 9
	items = firstItem + (itemPerShelf[currentShelf] - 1)
	for i = firstItem, items do
		if i%2 == 1 then
	 		drawItem(45, -15 + (alignment*100), 100, 10, shopItems.itemName[i], shopItems.price[i], shopItems.stock[i])
		else
	 		drawItem(265, -15 + (alignment*100), 100, 10, shopItems.itemName[i], shopItems.price[i], shopItems.stock[i])
	 		alignment=alignment+1
		end
		shelfItemNum[buttonNumber] = {colorid = shopItems.colorid[i], itemId = shopItems.itemId[i], itemName = shopItems.itemName[i], tryAble = shopCat[catSelected].tryAble, clickAble = true }
		buttonNumber = buttonNumber + 1
 	end

 	for a = buttonNumber, 10 do
		shelfItemNum[a].clickAble = false
		shelfItemNum[a].tryAble = false
 	end
end

function changeCategory()
	shopItemCount = 1
	currentShelf = 1
	lastShelfItems = 10
	placeItems()
end

function shopChangeColor(name, colorId)
	shopCat[catSelected].color = colorId 
	shopCat[catSelected].tryName = name 
	if shopCat[catSelected].tempStuff == 'ghost' then
		set_ghost(1)
	end 
end

local function setCamera()
        set_camera_lookat(0, -2, 1.5)
        set_camera_pos(8, -1, 1.5)
	return 1
end

local function drawOptions()
	set_color(0.0, 0.8, 0.9, 0.8)
	draw_centered_text("TORISHOP", 22, FONTS.BIG)
	set_color(0.0, 0.0, 0.0, 1.0)
	draw_centered_text("TORISHOP", 20, FONTS.BIG)

	draw_text("Page: " .. " " .. currentShelf .. "/" .. shelf, 5, quadHeight - 25)

	if toriCredits > 0 then
		draw_text("ToriCredits: " .. toriCredits, tc.pos.x, tc.pos.y)
	end

	drawPrevButton(catButtonPos.x, catButtonPos.y, button["prev_cat"].state)
	drawNextButton(catButtonPos.x2, catButtonPos.y, button["next_cat"].state)

	tempName = shopCategories[catSelected]
	if string.find(tempName, "ondary") ~= nil then
		tempName = string.gsub(tempName, "ondary", ".")
	elseif string.find(tempName, "mary") ~= nil then
		tempName = string.gsub(tempName, "mary", ".")
	end
	draw_text(tempName, catButtonPos.x + 20, catButtonPos.y - buttonH/2)			

	if shelf ~= 1 then
		drawPrevButton(itemButtonPos.x, itemButtonPos.y, button["prev_item"].state)
		drawNextButton(itemButtonPos.x2, itemButtonPos.y, button["next_item"].state)
	end

	drawItemsOnShelf()
	setButtonColor("link")
	draw_text("Visit the Torishop", link.pos.x, link.pos.y)

	if shopCat[catSelected].tryAble then
		setButtonColor("none")
		draw_text("None", none.pos.x, none.pos.y)
	end
	
	alignment=1
	for i = 1, itemPerShelf[currentShelf] do
		if i%2 == 1 then
			buyTryPosition(i, 0, alignment)
		else
			buyTryPosition(i, 220, alignment)
			alignment = alignment + 1
		end
	end
end

function buyTryPosition (number, offSet, alignment)
	setButtonColor(number .. "_buy")
	draw_text("BUY", buy.pos.x + offSet, buy.pos.y + (alignment*100) - 5)
	if shelfItemNum[number].tryAble then
		setButtonColor(number .. "_try")
		draw_text("TRY", try.pos.x + offSet,try.pos.y + (alignment*100) - 5)
	end
end

function onKeyUp (key)
	if key == string.byte(' ') then
		draw_ground_impact(0)		
		return 1
	end
end

function onKeyDown (key)
	-- wasd keys
	if key == 119 or key == 97 or key == 115 or key == 100 then 
		return 1
	end
	-- arrow keys
	if key >= 273 and key <= 276 then
		return 1
	end
end

function updateTori ()
	if available then
		for i = 1, shopCatCount do
			shopCat[i].setColor(0, shopCat[i].color)
		end
	end
end

function setButtonColor (name)
	if button[name].state == BTN_HOVER then
		set_color(1, 0, 1, 1)
	else
		set_color(0, 0, 0, 1)
	end
end

function buttonAction (buttonName)
	if (a == "link") then
		open_url("http://www.toribash.com/forum/tori_shop.php")
		return
	end	

	if buttonName == "prev_cat" then -- shop categories
		if catSelected > 1 then
			catSelected = catSelected - 1
		else
			catSelected = shopCatCount
		end
		changeCategory()		
	elseif buttonName == "next_cat" then -- shop categories
		if catSelected < shopCatCount then
			catSelected = catSelected + 1
		else
			catSelected = 1
		end
		changeCategory()
	elseif buttonName == "prev_item" then -- shop items 
		if currentShelf > 1 then
			currentShelf = currentShelf - 1
		else
			currentShelf = shelf
		end
	elseif buttonName == "next_item"  then -- shop items 
		if currentShelf < shelf	then
			currentShelf = currentShelf + 1
		else
			currentShelf = 1
		end
	elseif string.find(buttonName, "_buy", -4) ~= nil then
		buttonName = string.gsub(buttonName, "_buy", "")
		buttonName = tonumber(buttonName)
		if shelfItemNum[buttonName].clickAble	then
			open_url("http://forum.toribash.com/tori_trade.php?action=buyquery&item=" .. shelfItemNum[buttonName].itemId)
		end
	elseif string.find(buttonName, "_try", -4) ~= nil then
		buttonName = string.gsub(buttonName, "_try", "")
		buttonName = tonumber(buttonName)
		if shelfItemNum[buttonName].tryAble then
			shopChangeColor(shelfItemNum[buttonName].itemName, shelfItemNum[buttonName].colorid)
		end
	elseif buttonName == "none" then
		shopChangeColor("", 0)
	elseif buttonName =='online' and available then
		open_url("http://www.toribash.com/forum/tori_shop.php")
	end
end

function drawNavButton (x, y, state, start)
	inner = 5
	outer = 10
	if (state == BTN_HOVER) then
		inner = 8
		outer = 13
	elseif (state == BTN_DOWN) then
		inner = 2
		outer = 7
	end
	slices = 3 
	loops = 1
	sweep = 360
	blend = 0
	draw_disk(x, y, inner, outer, slices, loops, start, sweep, blend)	
end

function drawPrevButton (x, y, state)
	drawNavButton(x, y, state, 270)
end

function drawNextButton (x, y, state)
	drawNavButton(x, y, state, 90)
end

function mouseHit(x, y)
	for key, value in pairs(button) do
		button[key].state = BTN_UP
		if (x > button[key].x and y > button[key].y and x < button[key].x + button[key].w and y < button[key].y + button[key].h) then
			return  key
		end
	end
	return 0 
end

function mouseMove(x, y)
	a = mouseHit(x, y)
	if a ~= 0 then
		button[a].state = BTN_HOVER
	end
end

function mouseUp(mouseBtn, x, y)
	a = mouseHit(x, y)
	if a ~= 0 then
		button[a].state = BTN_HOVER
		if a == currentButton then
			buttonAction(a)
			updateTori()
			if shopCat[catSelected].tempStuff == "dqRing" and string.find(a, "_try") ~= nil then
				draw_ground_impact(0)
			end
		end
		currentButton = 0
	end
	return 1
end

function mouseDown(mouseBtn, x, y)
	a = mouseHit(x,y)
	if a ~= 0 then
		button[a].state = BTN_DOWN
		currentButton = a
	end
	return 1
end

function onLeaveGame()
	set_volume(originalVolume)
	for k, v in pairs(options) do
		set_option(k, v) 
	end
	remove_hooks("freeCam")
        remove_hooks("customplayer")
	remove_hooks("customplayer_button")
end

init()
add_hook("mouse_button_down", "customplayer_button", mouseDown)
add_hook("mouse_button_up", "customplayer_button", mouseUp)
add_hook("mouse_move", "customplayer_button", mouseMove)
add_hook("leave_game", "customplayer", onLeaveGame)
add_hook("key_up", "customplayer", onKeyUp)
add_hook("key_down", "customplayer", onKeyDown)
if available == true then
	add_hook("camera","freeCam", function() return setCamera(); end)
	add_hook("draw2d", "customplayer", function() drawOptions(); end)
else
	add_hook("draw2d", "customplayer", function() tsUnavailable(); end)
end
